<?php
defined( '_JEXEC' ) or die( 'Restricted access.' );

require_once(JPATH_ADMINISTRATOR.'/components/com_zoo/config.php');

class xmap_com_zoo {

    function getTags( &$xmap, &$parent, &$params) {

        $tags = YTable::getInstance('tag')->getAll();
        foreach($tags as $key=>$item) {
            $node = new stdclass;
            $node->id   = $key;
            $node->uid  = 'tag'.$key;
            $node->name = $item->name;
            $node->link = RouteHelper::getTagRoute(3, $item->name);
            $node->expandible = true;
            $xmap->printNode($node);
        }
    }

    function getTree( &$xmap, &$parent, &$params) {

        $link_query = parse_url( $parent->link );
        parse_str( html_entity_decode($link_query['query']), $link_vars );
        $view = JArrayHelper::getValue($link_vars,'view',0);

        $include_categories = JArrayHelper::getValue( $params, 'include_categories',1,'' );
        $include_categories = ( $include_categories == 1
                  || ( $include_categories == 2 && $xmap->view == 'xml')
                  || ( $include_categories == 3 && $xmap->view == 'html')
                  ||   $xmap->view == 'navigator');
        $params['include_categories'] = $include_categories;
                
        $include_items = JArrayHelper::getValue( $params, 'include_items',1,'' );
        $include_items = ( $include_items == 1
                  || ( $include_items == 2 && $xmap->view == 'xml')
                  || ( $include_items == 3 && $xmap->view == 'html')
                  ||   $xmap->view == 'navigator');
        $params['include_items'] = $include_items;

        $priority = JArrayHelper::getValue($params,'cat_priority',$parent->priority,'');
        $changefreq = JArrayHelper::getValue($params,'cat_changefreq',$parent->changefreq,'');
        if ($priority  == '-1')
            $priority = $parent->priority;
        if ($changefreq  == '-1')
            $changefreq = $parent->changefreq;

        $params['cat_priority'] = $priority;
        $params['cat_changefreq'] = $changefreq;

        $priority = JArrayHelper::getValue($params,'item_priority',$parent->priority,'');
        $changefreq = JArrayHelper::getValue($params,'item_changefreq',$parent->changefreq,'');
        if ($priority  == '-1')
            $priority = $parent->priority;

        if ($changefreq  == '-1')
            $changefreq = $parent->changefreq;

        $params['item_priority'] = $priority;
        $params['item_changefreq'] = $changefreq;

        xmap_com_zoo::getCategoryTree($xmap, $parent, $params);
        if ($xmap->view == 'xml') {
            xmap_com_zoo::getTags($xmap, $parent, $params);            
        }


    }

    function getCategoryTree ( &$xmap, &$parent, &$params) {

        // first we fetch what application we are talking about
        $menu =& JSite::getMenu();
        $menuparams = $menu->getParams($parent->id);
        $application_id =  intval($menuparams->get('application', 0));
        $category_id =  intval($menuparams->get('category', 0));
        
        if ($params['include_categories']) {
            $categories = YTable::getInstance('category')->getById($application_id, true);
            $xmap->changeLevel(1);
            foreach($categories as $category) {
                $node = new stdclass;
                $node->id   = $parent->id;
                $node->uid  = $parent->uid .'c'.$category->id;
                $node->name = $category->name;
                $node->link = RouteHelper::getCategoryRoute($category);
                $node->priority   = $params['cat_priority'];
                $node->changefreq = $params['cat_changefreq'];
                $node->expandible = true;
                $xmap->printNode($node);
            }
            $xmap->changeLevel(-1);
        }

        if ($params['include_items'] && $category_id > 0) {
            $items = YTable::getInstance('item')->getFromCategory($application_id, $category_id, true);
            $xmap->changeLevel(1);
            foreach($items as $item) {
                $node = new stdclass;
                $node->id   = $parent->id;
                $node->uid  = $parent->uid .'i'.$item->id;
                $node->name = $item->name;
                $node->modified = strtotime($item->modified);
                $node->link = RouteHelper::getItemRoute($item);
                $node->priority   = $params['item_priority'];
                $node->changefreq = $params['item_changefreq'];
                $node->expandible = true;
                $xmap->printNode($node);
            }
            $xmap->changeLevel(-1);
        }
    }

}
